//*****************************************************
// BK1088 & RadioLCD control progtam
// Main 
//              By Minarai Shokunin
//    http://crystal-radio.blogzine.jp/blog/
//*****************************************************

#include "P24FJ64GA004.h" 
#include "prototypes.h" 
#include "define.h" 

// Externals
extern unsigned int AM_FREQ[];
extern const unsigned int FM_FREQ[];
extern const unsigned int SW_FREQ[];
extern const unsigned int HW_RegAM[];
extern const unsigned int HW_RegFM[];
extern const unsigned int HW_Reg[];

extern unsigned int KEY_STATUS[];
extern unsigned int KEY_FLAGS[];
extern unsigned int KEY_TIMES[];

//config
_CONFIG2(0xF9FC);
_CONFIG1(0x3F7F);

//Variables
unsigned int coldata[3];	// display data for LCD display
unsigned int lcdstate;		// LCD timing 
unsigned int nVOL;			// VOLUME
unsigned int nBAND;			// Current band
unsigned int nFREQ[3];		// Frequency for each band
unsigned int nCHN[3];		// current channnel of each band
unsigned int nREG5;
unsigned int nDIV;

//main loop
int main(void)
{

   unsigned int i;
   unsigned long tim0;

   lcdstate =0;
   nDIV = 1;

   //Setup clock
   OSCCON	=	0x11C0;	 // FRCPLL
   CLKDIV	= 	0x0030;	 // 1MIPS SETTING

   //IO PORT SETTING
	AD1PCFG =	0xffff;	// Analog input disable
	TRISA	=	0x000f;	// All output (Will be changed)
	TRISB	=	0x0000;	// All output
	TRISC	=	0x00ff;	// PC7-PC0 are input
	PORTC 	= 	0xffff;

	// Switch INITIALIZE
	coldata[0] = 0;coldata[1] = 0;coldata[2] = 0;
	for (i=0;i<8;i++) {
		KEY_STATUS[i] = 0xffff;  
		KEY_FLAGS[i] = SWOFF;
		KEY_TIMES[i] = 0;		
	}	

	// Band/Freq initialize
	nBAND = 0;				// AM select
	nFREQ[0] = AM_FREQ[0]; 	// AM  
	nFREQ[1] = SW_FREQ[0] ; // SW 
	nFREQ[2] = FM_FREQ[0] ;	// FM
	nCHN[0] = 0;
	nCHN[1] = 0;
	nCHN[2] = 0; 
	tim0 = 0;
 
    // ^C}P̐ݒ@
    PR1 = 200;  		
    T1CON = 0b1000000000110000;
    IEC0bits.T1IE = 1; // ^C}P荞݋

   // WIIC
	nVOL = 0x1d;
	Set_Num(nFREQ[nBAND]);   	// SŎgw
	Set_Band(nBAND);			// ohw 0=AM / 1=SW / 2=FM
	Bk1088_Init();
	Set_Freq(nBAND,nFREQ[nBAND]);  // AMI

	//@烁C[v@

	while(1) {

		// Volume down

		if (KEY_FLAGS[5] == SWPUSHED) { // Volume down
			KEY_FLAGS[5] = SWOFF;
			if (nVOL >1) {nVOL--;}
			Set_Num(nVOL); 
			Set_Band(3);			    // oh\It
			nREG5 = (nREG5 & 0xffe0 )| nVOL;
			Bk1088_Write(0x05,nREG5); 
			tim0 = 500000;
		}

		// Volume up		

		if (KEY_FLAGS[6] == SWPUSHED) { // Volume up
			KEY_FLAGS[6] = SWOFF;
			if (nVOL <0x1f) {nVOL++;}
			Set_Num(nVOL);
			Set_Band(3);			    // oh\It
			tim0 = 500000;
			nREG5 = (nREG5 & 0xffe0 ) | nVOL;
			Bk1088_Write(0x05,nREG5); 			  
		}

		// Process after volume canging

		if (tim0 >0) {
			tim0 --;
			if (tim0 == 0) {
				if (nBAND==0){Set_Num(nFREQ[nBAND]);}
				if (nBAND==1){Set_Num(nFREQ[nBAND]/10);}
				if (nBAND==2){Set_Num(nFREQ[nBAND]/10);}
				Set_Band(nBAND);			// oh\
			}
		}

		// channel change

		if (KEY_FLAGS[1] == SWPUSHED) { // channel change
			tim0=0;
			KEY_FLAGS[1] = SWOFF;
			nCHN[nBAND]++;
			switch (nBAND) {
				case 0:	if (AM_FREQ[nCHN[nBAND]]==0) {nCHN[nBAND] =0;}
							Set_Freq(nBAND,AM_FREQ[nCHN[nBAND]]);  // AMI
							nFREQ[nBAND] = AM_FREQ[nCHN[nBAND]];
							Set_Num(nFREQ[nBAND]);   	// g\
							Set_Band(nBAND);			// oh\
							break;
				case 1:	if (SW_FREQ[nCHN[nBAND]]==0) {nCHN[nBAND] =0;}
							Set_Freq(nBAND,SW_FREQ[nCHN[nBAND]]);  // SWI
							nFREQ[nBAND] = SW_FREQ[nCHN[nBAND]];
							Set_Num(nFREQ[nBAND]/10);   	// g\
							Set_Band(nBAND);			// oh\
							break;
				case 2:	if (FM_FREQ[nCHN[nBAND]]==0) {nCHN[nBAND] =0;}
							Set_Freq(nBAND,FM_FREQ[nCHN[nBAND]]);  // FMI
							nFREQ[nBAND] = FM_FREQ[nCHN[nBAND]];
							Set_Num(nFREQ[nBAND]/10);   	// g\
							Set_Band(nBAND);			// oh\
							break;			
				default :
							break;			
			}
		}

		// band change

		if (KEY_FLAGS[2] == SWPUSHED) { // band change
			tim0=0;
			KEY_FLAGS[2] = SWOFF;
			switch (nBAND) {
				case 0 :	nBAND = 1; nDIV = 10;
							Set_Freq(nBAND,SW_FREQ[nCHN[nBAND]]);  // SWI
							Set_Num(nFREQ[nBAND]/nDIV);   	// g\
							Set_Band(nBAND);			// oh\
							break;
				case 1 :	nBAND = 2; nDIV = 10;
							Set_Freq(nBAND,FM_FREQ[nCHN[nBAND]]);  // FMI
							Set_Num(nFREQ[nBAND]/nDIV);   	// g\
							Set_Band(nBAND);			// oh\
							break;
				case 2 :	nBAND = 0; nDIV = 1;
							Set_Freq(nBAND,AM_FREQ[nCHN[nBAND]]);  // AMI
							Set_Num(nFREQ[nBAND]);   	// g\
							Set_Band(nBAND);			// oh\
							break;
				default :	nBAND = 0; nDIV = 1;
							Set_Freq(nBAND,AM_FREQ[nCHN[nBAND]]);  // AMI
							Set_Num(nFREQ[nBAND]);   	// g\
							Set_Band(nBAND);			// oh\
							break;
			}
		}

		// FREQ UP FAST

		if (KEY_FLAGS[4] == SWLONGPUSHING) { // FREQ UP fast
			tim0=0;
			nFREQ[nBAND]+=20;
			Set_Freq(nBAND,nFREQ[nBAND]);  // AMI
			Set_Num(nFREQ[nBAND]/nDIV);   	// g\
			Set_Band(nBAND);			// oh\
		}

		// FREQ DOWN FAST

		if (KEY_FLAGS[3] == SWLONGPUSHING) { // FREQ down fast
			tim0=0;
			if (nFREQ[nBAND] > 20 ) {nFREQ[nBAND] -=20;}
			Set_Freq(nBAND,nFREQ[nBAND]);  // AMI
			Set_Num(nFREQ[nBAND]/nDIV);   	// g\
			Set_Band(nBAND);			// oh\
		}

		// FREQ UP

		if (KEY_FLAGS[4] == SWPUSHED) { // FREQ UP
			tim0=0;
			KEY_FLAGS[4] = SWOFF;
			nFREQ[nBAND]++;
			Set_Freq(nBAND,nFREQ[nBAND]);  // AMI
			Set_Num(nFREQ[nBAND]/nDIV);   	// g\
			Set_Band(nBAND);			// oh\
		}

		// FREQ DOWN

		if (KEY_FLAGS[3] == SWPUSHED) { // FREQ UP
			tim0=0;
			KEY_FLAGS[3] = SWOFF;
			if (nFREQ[nBAND] > 0 ) {nFREQ[nBAND]--;}
			Set_Freq(nBAND,nFREQ[nBAND]);  // AMI
			Set_Num(nFREQ[nBAND]/nDIV);   	// g\
			Set_Band(nBAND);			// oh\
		}

	}
}


// SEGMENT CONTROL@LCD𐧌

void __attribute__((interrupt, auto_psv)) 
   _T1Interrupt(void)
{
	unsigned int wk;
	wk = coldata[lcdstate/2];

	if ((lcdstate%2)==0) {
		PORTB = wk ^ 0xffff;						// IZOgOVɂ
		PORTA = 0xffff;
		switch (lcdstate/2) {								// ColI@IColPhCuiRVj
			case 0 :								// ȊO̓t[giPDTVj
					TRISA = 0xfffe;break;
			case 1 :	
					TRISA = 0xfffd;break;
			case 2 :	
					TRISA = 0xfeff;break;
			default :break;
		}
	}else{
		PORTB = wk;									// IZOgRVɂ
		PORTA = 0x0000;								// IColOVɁBȊO͂PDTV̂܂
	}
	lcdstate++;
	if (lcdstate>5) {
		lcdstate =0;
	}
   
   Key_Scan();

   IFS0bits.T1IF = 0;// 荞݃tONA
}

// WAIT LOOP@KȃEFCg[`

void Wait_Time(unsigned int t) {
	int t0,t1;
	for (t0=0;t0